from src.batch.ultmarc.utmp_tables.table_mapper.ultmarc_table_mapper import \
    UltmarcTableMapper
from src.batch.ultmarc.utmp_tables.tables.com_snd_med_sphe import ComSndMedSphe


class ComSndMedSpheMapper(UltmarcTableMapper):
    """レイアウト区分123: COM_医療圏二次医療圏 登録処理"""

    # レコード存在確認SQL
    RECORD_EXISTS_QUERY = """\
    SELECT
        COUNT(*) AS count_num
    FROM
        src05.com_snd_med_sphe
    WHERE
        prefc_cd = :prefc_cd
        AND
        med_sphe_cd = :med_sphe_cd
    """
    # データ登録用SQL
    INSERT_QUERY = """\
    INSERT INTO src05.com_snd_med_sphe
    (
        prefc_cd,
        med_sphe_cd,
        thrd_cd,
        snd_med_sphe_name,
        requd_bed_or_equip_target,
        exist_bed_num,
        exist_bed_num_regist_ymd,
        plsmns_bed_num,
        regist_ymd,
        sys_regist_date,
        regist_prgm_id,
        sys_update_date,
        update_prgm_id
    )
    VALUES (
        :prefc_cd,
        :med_sphe_cd,
        :thrd_cd,
        :snd_med_sphe_name,
        :requd_bed_or_equip_target,
        :exist_bed_num,
        :exist_bed_num_regist_ymd,
        :plsmns_bed_num,
        :execute_date_str_ymd,
        :execute_datetime,
        :program_name,
        :execute_datetime,
        :program_name
    )
    """

    # データ更新用SQL
    UPDATE_QUERY = """\
    UPDATE
        src05.com_snd_med_sphe
    SET
        thrd_cd = :thrd_cd,
        snd_med_sphe_name = :snd_med_sphe_name,
        requd_bed_or_equip_target = :requd_bed_or_equip_target,
        exist_bed_num = :exist_bed_num,
        exist_bed_num_regist_ymd = :exist_bed_num_regist_ymd,
        plsmns_bed_num = :plsmns_bed_num,
        update_ymd = :execute_date_str_ymd,
        sys_update_date = :execute_datetime,
        update_prgm_id = :program_name
    WHERE
        prefc_cd = :prefc_cd
        AND
        med_sphe_cd = :med_sphe_cd
    """

    # 修正区分が「C(削除)」の場合、物理削除
    PHYSICAL_DELETE_QUERY = """\
    DELETE FROM
        src05.com_snd_med_sphe
    WHERE
        prefc_cd = :prefc_cd
        AND
        med_sphe_cd = :med_sphe_cd
    """

    record: ComSndMedSphe

    def __init__(self, record: list[str], db) -> None:
        super().__init__(record, db, ComSndMedSphe)
        program_name = __name__.split('.')[-1]  # 当モジュール名(現行から変わっている)
        # モジュール名をクエリパラメータに設定
        self.query_parameter['program_name'] = program_name
        # 読み込んだレコード値もクエリパラメータに追加
        self.query_parameter = {**self.query_parameter, **self.record.to_sql_parameter()}

    def make_query(self):
        # 修正区分がC(削除)の場合、物理削除
        if self.record.maintflag == 'C':
            self.queries.append(self.PHYSICAL_DELETE_QUERY)
            return

        # 追加、更新の場合
        self.queries.append(self.__make_upsert_query())
        return

    def __make_upsert_query(self):
        # レコードの存在確認
        record_count = self.db.execute_select(self.RECORD_EXISTS_QUERY, self.query_parameter)
        # 存在しない場合はInsert
        if record_count[0]['count_num'] == 0:
            return self.INSERT_QUERY

        # 存在する場合はUpdate
        return self.UPDATE_QUERY
